function procolumns(id) {
    return {
        columns: [
            {
                title: '点检项目',
                dataIndex: 'checkItem',
                key: 'checkItem',
                formItemProps: { rules: [{ required: true, message: '此项为必填项' }] },
            },
            {
                title: '点检部位',
                dataIndex: 'checkPosition',
                key: 'checkPosition',
                formItemProps: { rules: [{ required: true, message: '此项为必填项' }] },
            },
            {
                title: '点检方法',
                dataIndex: 'checkWay',
                key: 'checkWay',
                colProps: { span: 24 },
                valueType: 'textarea',
            },
            {
                title: '判断类型',
                dataIndex: 'judgeTypeName',
                key: 'judgeType',
                formItemProps: { rules: [{ required: true, message: '此项为必填项' }] },
                valueType: 'select',
                options: [
                    { label: '定性', value: 1 },
                    { label: '定量', value: 2 },
                ],
                hideInSearch: true,
            },
            {
                title: '下限值',
                dataIndex: 'lowerLimit',
                key: 'lowerLimit',
                formItemProps: { rules: [{ required: true, message: '此项为必填项' }] },
                hideInForm: { judgeType: [1, null, undefined] },
                valueType: 'digit',
                hideInSearch: true,
                min: -10000000000000000
            },
            {
                title: '上限值',
                dataIndex: 'upperLimit',
                key: 'upperLimit',
                formItemProps: { rules: [{ required: true, message: '此项为必填项' }] },
                valueType: 'digit',
                hideInForm: { judgeType: [1, null, undefined] },
                hideInSearch: true,
                min: -10000000000000000
            },
            {
                title: '预计工时',
                dataIndex: 'estimatedWork',
                key: 'estimatedWork',
                valueType: 'digit',
                hideInSearch: true,
            },
            {
                title: '备注',
                dataIndex: 'remark',
                key: 'remark',
                colProps: { span: 24 },
                valueType: 'textarea',
                hideInSearch: true,
            },
        ],
        pathconfig: {
            enableadd: true,
            enableedit: true,
            enabledelete: true,
            enabledetail: false,
            add: '/check/umEquipmentCheckItem/save',
            edit: '/check/umEquipmentCheckItem/save',
            list: '/check/umEquipmentCheckItem/queryList',
            delete: '/check/umEquipmentCheckItem/deleteById',
            detail: '',
        },
    };
}
export default procolumns;
