function getcolumns(equipmentModelId) {
  return {
    columns: [
      {
        title: '标准编号',
        dataIndex: 'standardNo',
        key: 'standardNo',
        hideInForm: true,
      },
      {
        title: '保养类型',
        dataIndex: 'maintainTypeName',
        key: 'maintainType',
        formItemProps: {
          rules: [
            {
              required: true,
              message: '此项为必填项',
            },
          ],
        },
        valueType: 'select',
        mode: 'radio',
        options: [
          {
            label: '专业保养',
            value: 2,
          },
          {
            label: '自主保养',
            value: 1,
          },
        ],
      },
      {
        title: '设备型号',
        dataIndex: 'equipmentModelName',
        key: 'equipmentModelId',
        valueType: 'select',
        formItemProps: {
          rules: [
            {
              required: true,
              message: '此项为必填项',
            },
          ],
        },
        mode: 'radio',
        options: {
          path: '/maintain/umMaintainStandard/selected/queryList',
          linkParams: {
            maintainType: 'maintainType',
          },
          extraParams: {
            equipmentModelId,
          },
        },
      },
      {
        title: '备注',
        dataIndex: 'remark',
        key: 'remark',
        span: 24,
        valueType: 'textarea',
        hideInSearch: true,
      },
    ],
    pathconfig: {
      enableadd: true,
      enableedit: true,
      enabledelete: true,
      enabledetail: false,
      add: '/maintain/umMaintainStandard/save',
      edit: '/maintain/umMaintainStandard/save',
      list: '/maintain/umMaintainStandard/queryList',
      delete: '/maintain/umMaintainStandard/deleteById',
      detail: '',
    },
  };
}
export default getcolumns;
